# Overview
* Adding option to log out.
* Changed to use prepared sql statements to prevent sql injection.
* Store users in a database to persist user information.
* Added password checks to improve authentication.
* Added a registration page to create new users.
* Used BCrypt to store hashed passwords.
* Changed app.secret_key to a random more secure value.
* Added the flags secure and samesite for session cookies.
* Message overhaul

# Logging out
Since the original application did not have a userfriendly way to log out, I added it to the index page.

To use it, simply click the log out link in the top left of the index page. It should automatically log out the user and send the user to the log out screen.

The logout function was implemented by adding a hyperlink to index.html that send the user to http://localhost:5000/logout. Then flask uses logout_user() to log out the user.

# SQL statements
The original application were vulnerable to SQL injection. To combat this, all interactions with the database now uses prepared statements instead.

Attempts at SQL injection can be written in all input areas where the user can write, though none should exceed now.
E.g writing "*'; INSERT INTO messages (sender, message) VALUES ('Attacker', 'A malicious message');--" into the search input on the index page would in the past add a new message to the database, while now it would just be the message the database search for, with no ill-intended side effects.

It was simply implemented by using prepared statements. Instead of inserting the value directly into the statement, use a question mark, and add the values as a second argument to conn.execute

# Storing users
User information should persist even when the server is down. Therefore, that information must be stored outside of app.py. Now user information is stored in tiny.db in a new table.

To test that it works, run the server, create a user, shut down the server, start the server again and finally log in with the previously created user.

Implementation required a bit of work. If the users table does not exist, create it. It should store usernames as primary key, and their hashed passwords. When successfully registering, the username and the hashed password gets inserted into the users table by using prepared statements.

When checking whether the database already contains a specific username, it uses a prepared SQL statement to get the rows with the specific username. If c.fetchone() gives None, the username is not located in the table. Checking username and password is very similiar, but if a row exists, get the hashed password from the row.

# Checks passwords
Originally, only the usernames were enough to log in as no checks were done to see if the password was correct. Checks for passwords have now been added.

To test, simply create a user, then on the login page, which is http://localhost:5000/login, try to log in to the user. It should only log in if the password is correct.

Uses bcrypt.check_password_hash to check is the entered password fits with the stored hashed password, and added the function check_username_and_passwords where approprtiate. E.g in the login function.

# Registration
Added a new page http://localhost:5000/register so that new users can register.

To use, go to http://localhost:5000/register and type in a username and password and submit. If the username has not been taken, and the username and password has a length between 1 and 30 inclusive, then the new user will be registered, but not automatically logged in. Upon successful registration, you will be redirected to the login page.

Created register.html and added the class RegistrationForm to login_form.py. register() works similiarly to login(). Instead of making sure the username already exists with the correct password, it checks that the username does not already exist, then uses bcrypt to generate hash_password and inserts username and hash_password into the users table using prepared statements.

# BCrypt
To encrypt the passwords, BCrypt is used, as it both hashes and salts passwords.

When registering a new user, a hash_password is generated with bcrypt.generate_password_hash(password), which is then stored in the users table. When logging in, the entered password is compared with the stored hash_password using bcrypt.check_password_hash(hashed_password, password).

# Secret key
Changed app.secret_key to a value that is harder to guess. Was generated by running print(secrets.token_hex()), then copy the output and paste it as the value of app.secret_key.

# Cookie flags
To make the session cookie more secure, the flags secure and samesite was enabled.

Can be checked by logging in, then when inspecting the cookie on the site, secure should be enabled and samesite should be set to strict.

Implemented by writing the line "app.config.update(SESSION_COOKIE_SECURE = True, SESSION_COOKIE_SAMESITE = 'Strict')".

# Message overhaul
Messages now has an id, a sender, an recipient and the text message. When sending a message, instead of letting the sender write who the supposed sender is, now instead is a field to write who should recieve the message. The sender gets added automatically by the application. Users can now only see messages that they either sent or received.

To test, use multiple users to send different messages to multiple other users, then press show all or search as different users to see which messages they can see.

Implemented by adding a recipent column in the messages table. In search() and send(), gets current user from current_user.get_id() and add it as the sender in send(), and use WHERE to get only messages that has current user as either recipent or sender in search()

# Questions

# Threat model
The application does not have much of value to attack, but there are some. Someone may want to attack to get the passwords of users, as the users may use the same password in other places. They may want access to the information in the databases, like the messages between to other users. They also may just be someone who wants to cause trouble. If someone manages to mess with the database, a lot of damage can be afflicted. They may steal information from it, or they may delete the tables altogether. 

While it is possible to prevent certain attacks completely, there are other attacks that cannot be prevented completely, can only be mitigated.

# Main attack vectors and protection against them.
The main attack vectors are probably SQL injection, CSRF, compromised credentials.

SQL injections can be prevented using prepared statements, something the application uses.

To prevent CSRF attacks, use CSRF tokens and enable cookies samesite flag. This application sets the samesite flag to strict for the session cookie.

Compromised credentials be migated by using hashing and salting. This application uses BCrypt to do both. An attacker may still brute force or guess passwords. Passwords can in this application be very weak, so some may be very easy to guess. Passwords could have been strengthened by forcing a higher minimum lenght and requiring at least one of different types of symbols, like digit, lowercase letter and uppercase letter, but that has not been implemented.

# Access control model
This application uses Relationship-Based Access Control. A user is only able to see messages that they either sent or recieved.